> MATRIX OS (MOS) has been deprecated. We are no longer providing support for it and it may cease to function at any time. Please refer to our new library [MATRIX Lite](https://github.com/matrix-io/matrix-lite-js) to easily program your MATRIX Device with just one line of code.

# MATRIX OS

[![Build Status](https://travis-ci.org/matrix-io/matrix-os.svg?branch=master)](https://travis-ci.org/matrix-io/matrix-os)

![matrix os launches](http://i.makeagif.com/media/5-10-2016/TDceSN.gif)

# Overview
MATRIX Open Source is a platform for running applications on the MATRIX Creator.

###### Bugs
https://github.com/matrix-io/matrix-os/issues

###### Questions
http://community.matrix.one

###### Documentation & Installation Instructions
https://creator.matrix.one/#!/develop/start

## MATRIX Applications
MATRIX applications are built in JavaScript to logically connect sensor and computer vision data streams with outputs, such as LED lights, sending voltages, integrations and data for dashboards and analysis.

An example application would recognize your face and unlock your front door. A security gesture could be added for a basic level of access control. A 2 factor QR Code provided over the phone or fingerprint reader could be integrated more security.

Using [configuration files](https://matrix-io.github.io/matrix-documentation/Configuration/examples/), an application end-user could customize an application for their specific use case. Adding API keys or custom phrases.

#### Why JavaScript?
Lots of people already know JavaScript, and there is a rich module ecosystem. Part of our goal is to put IoT into the hands of more people.

#### What about MY language?
Don't worry. We like other languages too, all it will need is a supporting SDK. Coming soon.

#### Applications?
 MATRIX Applications can be used in the traditional manner of an app, single user, single device. We believe swarming meshes of interconnected data streams will be a more common pattern. Most devices will use many applications at once, and many will operate entirely without direct manipulation by an end user. We have built [inter-app messaging protocols](https://matrix-io.github.io/matrix-documentation/API/cross-talk) to help this.

#### Open Source
We built MATRIX on top of open source software and we are releasing it for everyone to see under the hood and make contributions😎. We believe in open access to information, especially for the IoT space, where security and privacy are of the utmost importance.

## Great, how do I use the thing over the internet?
Right now, you need a MATRIX Creator, available at [creator.matrix.one]().

Then follow the installation instructions above.
